
#include "process.h"
#include "console.h"
#include "segment.h"

tss_struct *cpu_tss;
task_union *init_stack;
task_struct *init_pcb;
task_struct *current;

unsigned int reg;
	
#define USER1_ADDR		0x40002000
#define USER1_PCB_ADDR	0x40003000
#define USER2_ADDR		0x40004000
#define USER2_PCB_ADDR	0x40005000

void user1(void)
{
	char *bp = (char *)0xb8004;
	volatile int a = 0;

	while (1) {
		(*bp)++;
		a++;
	}

}


task_struct *user1_pcb = (task_struct *)USER1_PCB_ADDR;
void init_user1(void)
{
	int l;
	unsigned char *src, *dst;
	
	// copy user1 to 0x40001fff
	caos_printf("Copy user1 process to 0x4000 2000\n");
	src = (unsigned char *)user1;
	dst = (unsigned char *)USER1_ADDR;
	for (l=0 ; l < 4096; l++) // copy one page
		*dst++ = *src++;
	
	user1_pcb->thread.eip = (unsigned int)USER1_ADDR;
	user1_pcb->thread.esp = (unsigned int)USER1_ADDR+0xfff;
	user1_pcb->thread.esp0 = (unsigned int)USER1_PCB_ADDR+0xfff;
	user1_pcb->thread.cs = __USER_CS;
	user1_pcb->thread.eflags = 0x200;
	user1_pcb->thread.ss = __USER_DS;
	user1_pcb->thread.ds = __USER_DS;
	user1_pcb->thread.es = __USER_DS;
	user1_pcb->thread.fs = __USER_DS;
	user1_pcb->thread.gs = __USER_DS;

	src = (unsigned char *)user1;
	dst = (unsigned char *)USER1_ADDR;
	caos_printf("Is it same? : ");
	caos_printf("<%x %x %x %x>", *src++, *src++,*src++,*src++);
	caos_printf("<%x %x %x %x>\n", *dst++, *dst++,*dst++,*dst++);

	

}

unsigned int user1_regs;

unsigned int eip, cs, eflags, esp, ss;

void init(void)
{

	char *bp = (char *)0xb8000;
	volatile int a=1;

	while(1) {
		(*bp)++;
		a++;
		if (a == 0)
		  bp++;
	}

}

void init_process(void)
{
	int l;

	//
	// read pointer of TSS from 0x9000, somewhere over 0x9XXX
	//
	unsigned int tmp = *(unsigned int *)TSS_WHERE;
	char *src, *dst;

	// kernel mode stack & process table
	init_stack = (task_union *)0x40001000;
	init_pcb = (task_struct *)init_stack;

	// First process is init
	current = init_pcb;

	// TSS for CPU
	cpu_tss = (tss_struct *)tmp;


	caos_printf("CPU TSS is at->%x\n", 
					(unsigned int)cpu_tss, (unsigned int)init_pcb);

	// Kernel Stack segment = 0x10
	cpu_tss->ss0 = 0x10;

	// copy init function at 0x4000 0000
	caos_printf("Copy init function at 0x4000 0000\n");
	src = (char *)init;
	dst = (char *)0x40000000;

	for (l=0; l < 4096; l++) // copy one page
		*dst++ = *src++;

	// setup PCB of init process
	init_pcb->thread.eip = (unsigned int)0x40000000;
	init_pcb->thread.esp = (unsigned int)0x40000fff;
	init_pcb->thread.esp0 = (unsigned int)0x40001fff;
	init_pcb->thread.cs = __USER_CS;
	init_pcb->thread.eflags = 0x200;// set only interrupt flag
	init_pcb->thread.ss = __USER_DS;
	init_pcb->thread.ds = __USER_DS;
	init_pcb->thread.es = __USER_DS;
	init_pcb->thread.fs = __USER_DS;
	init_pcb->thread.gs = __USER_DS;

}



void start_init(void)
{	
	reg = (unsigned int)&(init_pcb->thread);

	asm volatile (
		"cli							\n\t"
		/* 
		 * Before load TR, TSS must be initialized.
		 * Therefore kernel stack pointer is store at cpu_tss->esp0.
		 */ 
		"mov %1, %%eax		\n\t"
		"mov %%eax, %0		\n\t"
		/* load TR with TSS selector */
		"mov $0x20, %%ax	\n\t"
		"ltr %%ax			\n\t"
		"mov %2, %%esp		\n\t"
		"popa				\n\t"
		"pop %%ds				\n\t"
		"pop %%es				\n\t"
		"pop %%fs				\n\t"
		"pop %%gs				\n\t"
		"sti						\n\t"
		"iret						\n\t"
		: "=m"(cpu_tss->esp0)
		: "m"(init_pcb->thread.esp0),"m"(reg)
	);
}
		

